'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var React = require('react');
var MonacoEditor = require('@monaco-editor/react');
var graphqlLanguageService = require('graphql-language-service');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

function _interopNamespace(e) {
  if (e && e.__esModule) return e;
  var n = Object.create(null);
  if (e) {
    Object.keys(e).forEach(function (k) {
      if (k !== 'default') {
        var d = Object.getOwnPropertyDescriptor(e, k);
        Object.defineProperty(n, k, d.get ? d : {
          enumerable: true,
          get: function () {
            return e[k];
          }
        });
      }
    });
  }
  n['default'] = e;
  return Object.freeze(n);
}

var React__namespace = /*#__PURE__*/_interopNamespace(React);
var MonacoEditor__default = /*#__PURE__*/_interopDefaultLegacy(MonacoEditor);

function ownKeys(object, enumerableOnly) {
  var keys = Object.keys(object);

  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);

    if (enumerableOnly) {
      symbols = symbols.filter(function (sym) {
        return Object.getOwnPropertyDescriptor(object, sym).enumerable;
      });
    }

    keys.push.apply(keys, symbols);
  }

  return keys;
}

function _objectSpread2(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i] != null ? arguments[i] : {};

    if (i % 2) {
      ownKeys(Object(source), true).forEach(function (key) {
        _defineProperty(target, key, source[key]);
      });
    } else if (Object.getOwnPropertyDescriptors) {
      Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
    } else {
      ownKeys(Object(source)).forEach(function (key) {
        Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
      });
    }
  }

  return target;
}

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
  try {
    var info = gen[key](arg);
    var value = info.value;
  } catch (error) {
    reject(error);
    return;
  }

  if (info.done) {
    resolve(value);
  } else {
    Promise.resolve(value).then(_next, _throw);
  }
}

function _asyncToGenerator(fn) {
  return function () {
    var self = this,
        args = arguments;
    return new Promise(function (resolve, reject) {
      var gen = fn.apply(self, args);

      function _next(value) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
      }

      function _throw(err) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
      }

      _next(undefined);
    });
  };
}

function _classCallCheck$1(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}

function _defineProperties$1(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ("value" in descriptor) descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass$1(Constructor, protoProps, staticProps) {
  if (protoProps) _defineProperties$1(Constructor.prototype, protoProps);
  if (staticProps) _defineProperties$1(Constructor, staticProps);
  return Constructor;
}

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

function _extends() {
  _extends = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };

  return _extends.apply(this, arguments);
}

function _inherits$1(subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function");
  }

  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      writable: true,
      configurable: true
    }
  });
  if (superClass) _setPrototypeOf$1(subClass, superClass);
}

function _getPrototypeOf$1(o) {
  _getPrototypeOf$1 = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
    return o.__proto__ || Object.getPrototypeOf(o);
  };
  return _getPrototypeOf$1(o);
}

function _setPrototypeOf$1(o, p) {
  _setPrototypeOf$1 = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
    o.__proto__ = p;
    return o;
  };

  return _setPrototypeOf$1(o, p);
}

function _isNativeReflectConstruct$1() {
  if (typeof Reflect === "undefined" || !Reflect.construct) return false;
  if (Reflect.construct.sham) return false;
  if (typeof Proxy === "function") return true;

  try {
    Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}

function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null) return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;

  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0) continue;
    target[key] = source[key];
  }

  return target;
}

function _objectWithoutProperties(source, excluded) {
  if (source == null) return {};

  var target = _objectWithoutPropertiesLoose(source, excluded);

  var key, i;

  if (Object.getOwnPropertySymbols) {
    var sourceSymbolKeys = Object.getOwnPropertySymbols(source);

    for (i = 0; i < sourceSymbolKeys.length; i++) {
      key = sourceSymbolKeys[i];
      if (excluded.indexOf(key) >= 0) continue;
      if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
      target[key] = source[key];
    }
  }

  return target;
}

function _assertThisInitialized$1(self) {
  if (self === void 0) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return self;
}

function _possibleConstructorReturn$1(self, call) {
  if (call && (typeof call === "object" || typeof call === "function")) {
    return call;
  }

  return _assertThisInitialized$1(self);
}

function _createSuper$1(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct$1();

  return function _createSuperInternal() {
    var Super = _getPrototypeOf$1(Derived),
        result;

    if (hasNativeReflectConstruct) {
      var NewTarget = _getPrototypeOf$1(this).constructor;

      result = Reflect.construct(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }

    return _possibleConstructorReturn$1(this, result);
  };
}

function _slicedToArray(arr, i) {
  return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest();
}

function _toConsumableArray(arr) {
  return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread();
}

function _arrayWithoutHoles(arr) {
  if (Array.isArray(arr)) return _arrayLikeToArray(arr);
}

function _arrayWithHoles(arr) {
  if (Array.isArray(arr)) return arr;
}

function _iterableToArray(iter) {
  if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter);
}

function _iterableToArrayLimit(arr, i) {
  var _i = arr && (typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]);

  if (_i == null) return;
  var _arr = [];
  var _n = true;
  var _d = false;

  var _s, _e;

  try {
    for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) {
      _arr.push(_s.value);

      if (i && _arr.length === i) break;
    }
  } catch (err) {
    _d = true;
    _e = err;
  } finally {
    try {
      if (!_n && _i["return"] != null) _i["return"]();
    } finally {
      if (_d) throw _e;
    }
  }

  return _arr;
}

function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}

function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;

  for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];

  return arr2;
}

function _nonIterableSpread() {
  throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

function _createForOfIteratorHelper(o, allowArrayLike) {
  var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"];

  if (!it) {
    if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") {
      if (it) o = it;
      var i = 0;

      var F = function () {};

      return {
        s: F,
        n: function () {
          if (i >= o.length) return {
            done: true
          };
          return {
            done: false,
            value: o[i++]
          };
        },
        e: function (e) {
          throw e;
        },
        f: F
      };
    }

    throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
  }

  var normalCompletion = true,
      didErr = false,
      err;
  return {
    s: function () {
      it = it.call(o);
    },
    n: function () {
      var step = it.next();
      normalCompletion = step.done;
      return step;
    },
    e: function (e) {
      didErr = true;
      err = e;
    },
    f: function () {
      try {
        if (!normalCompletion && it.return != null) it.return();
      } finally {
        if (didErr) throw err;
      }
    }
  };
}

function removeFalsey(obj) {
  return !!obj;
}
var coreDiagnosticsSource = {
  forDocument: function forDocument(_ref) {
    return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
      var model, document, languageService;
      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              model = _ref.model, document = _ref.document, languageService = _ref.languageService;
              return _context.abrupt("return", languageService.getDiagnostics(model.uri.toString(), document).then(function (diag) {
                return diag.map(toMarkerData);
              }).catch(function (e) {
                if ('message' in e && 'locations' in e) {
                  return [toMarkerData({
                    severity: graphqlLanguageService.DIAGNOSTIC_SEVERITY.Error,
                    message: e.message,
                    source: 'GraphQL: Syntax',
                    range: graphqlLanguageService.getRange(e.locations[0], document)
                  })];
                } else {
                  console.warn("GraphQL getDiagnostics failed unexpected error: ", e);
                  return [];
                }
              }));

            case 2:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }))();
  }
};
var coreDefinitionSource = {
  forNode: function forNode(_ref2) {
    var schema = _ref2.schema,
        model = _ref2.model,
        token = _ref2.token;

    if (token.state && token.state.kind === 'NamedType' && token.state.name) {
      var type = schema.getType(token.state.name);

      if (type && type.astNode && type.astNode.loc) {
        return [{
          range: {
            startLineNumber: type.astNode.loc.startToken.line,
            startColumn: type.astNode.loc.startToken.column,
            endLineNumber: type.astNode.loc.endToken.line + 1,
            endColumn: type.astNode.loc.endToken.column
          },
          uri: model.uri
        }];
      }
    }

    return [];
  }
};
var coreHoverSource = {
  forNode: function forNode(_ref3) {
    var schema = _ref3.schema,
        document = _ref3.document,
        position = _ref3.position,
        token = _ref3.token;
    return {
      value: graphqlLanguageService.getHoverInformation(schema, document, position, token)
    };
  }
};
var debugHoverSource = {
  forNode: function forNode(_ref4) {
    var token = _ref4.token;
    return {
      value: '```json\n' + JSON.stringify(token.state, null, 2) + '\n```'
    };
  }
};
function toGraphQLPosition(position) {
  return new graphqlLanguageService.Position(position.lineNumber - 1, position.column - 1);
}
function toMarkerData(diagnostic) {
  return {
    startLineNumber: diagnostic.range.start.line + 1,
    endLineNumber: diagnostic.range.end.line + 1,
    startColumn: diagnostic.range.start.character + 1,
    endColumn: diagnostic.range.end.character,
    message: diagnostic.message,
    severity: 5,
    // severity: toMonacoSeverity(diagnostic.severity),
    code: diagnostic.code || undefined
  };
}
function toMonacoRange(range) {
  return {
    startLineNumber: range.start.line + 1,
    startColumn: range.start.character + 1,
    endLineNumber: range.end.line + 1,
    endColumn: range.end.character + 1
  };
}
function showWidgetInPosition(editorInstance, position, htmlElement) {
  editorInstance.changeViewZones(function (changeAccessor) {
    changeAccessor.addZone({
      afterLineNumber: position.line + 1,
      heightInPx: 60,
      domNode: htmlElement
    });
  });
}

var EnrichedLanguageService = /*#__PURE__*/function (_LanguageService) {
  _inherits$1(EnrichedLanguageService, _LanguageService);

  var _super = _createSuper$1(EnrichedLanguageService);

  function EnrichedLanguageService() {
    _classCallCheck$1(this, EnrichedLanguageService);

    return _super.apply(this, arguments);
  }

  _createClass$1(EnrichedLanguageService, [{
    key: "getNodeAtPosition",
    value: function () {
      var _getNodeAtPosition = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(schema, document, position) {
        var token;
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                if (!schema) {
                  _context.next = 4;
                  break;
                }

                token = graphqlLanguageService.getTokenAtPosition(document, position);

                if (!token) {
                  _context.next = 4;
                  break;
                }

                return _context.abrupt("return", token);

              case 4:
                return _context.abrupt("return", null);

              case 5:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));

      function getNodeAtPosition(_x, _x2, _x3) {
        return _getNodeAtPosition.apply(this, arguments);
      }

      return getNodeAtPosition;
    }()
  }, {
    key: "buildBridgeForProviders",
    value: function () {
      var _buildBridgeForProviders = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(model, position) {
        var graphQLPosition, document, schema, tokenAtPosition;
        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                graphQLPosition = toGraphQLPosition(position);
                document = model.getValue();
                _context2.next = 4;
                return this.getSchema();

              case 4:
                schema = _context2.sent;

                if (schema) {
                  _context2.next = 7;
                  break;
                }

                return _context2.abrupt("return", null);

              case 7:
                _context2.next = 9;
                return this.getNodeAtPosition(schema, document, graphQLPosition);

              case 9:
                tokenAtPosition = _context2.sent;

                if (tokenAtPosition) {
                  _context2.next = 12;
                  break;
                }

                return _context2.abrupt("return", null);

              case 12:
                return _context2.abrupt("return", {
                  languageService: this,
                  position: graphQLPosition,
                  document: document,
                  schema: schema,
                  token: tokenAtPosition,
                  model: model
                });

              case 13:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function buildBridgeForProviders(_x4, _x5) {
        return _buildBridgeForProviders.apply(this, arguments);
      }

      return buildBridgeForProviders;
    }()
  }, {
    key: "getDefinitionProvider",
    value: function getDefinitionProvider(rawSources) {
      var _this = this;

      var sources = [].concat(_toConsumableArray(rawSources), [coreDefinitionSource]);
      return {
        provideDefinition: function () {
          var _provideDefinition = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3(model, position) {
            var _ref;

            var bridge, nestedArrays, items;
            return regeneratorRuntime.wrap(function _callee3$(_context3) {
              while (1) {
                switch (_context3.prev = _context3.next) {
                  case 0:
                    _context3.next = 2;
                    return _this.buildBridgeForProviders(model, position);

                  case 2:
                    bridge = _context3.sent;

                    if (bridge) {
                      _context3.next = 5;
                      break;
                    }

                    return _context3.abrupt("return", []);

                  case 5:
                    _context3.next = 7;
                    return Promise.all(sources.map(function (source) {
                      return source.forNode(bridge);
                    }));

                  case 7:
                    nestedArrays = _context3.sent.filter(Boolean);
                    items = (_ref = []).concat.apply(_ref, _toConsumableArray(nestedArrays));
                    return _context3.abrupt("return", items);

                  case 10:
                  case "end":
                    return _context3.stop();
                }
              }
            }, _callee3);
          }));

          function provideDefinition(_x6, _x7) {
            return _provideDefinition.apply(this, arguments);
          }

          return provideDefinition;
        }()
      };
    }
  }, {
    key: "getHoverProvider",
    value: function getHoverProvider(rawSources) {
      var _this2 = this;

      var sources = [].concat(_toConsumableArray(rawSources), [coreHoverSource]);
      return {
        provideHover: function () {
          var _provideHover = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee5(model, position) {
            var info, contents;
            return regeneratorRuntime.wrap(function _callee5$(_context5) {
              while (1) {
                switch (_context5.prev = _context5.next) {
                  case 0:
                    _context5.next = 2;
                    return _this2.buildBridgeForProviders(model, position);

                  case 2:
                    info = _context5.sent;

                    if (info) {
                      _context5.next = 5;
                      break;
                    }

                    return _context5.abrupt("return");

                  case 5:
                    _context5.next = 7;
                    return Promise.all(sources.map( /*#__PURE__*/function () {
                      var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4(source) {
                        return regeneratorRuntime.wrap(function _callee4$(_context4) {
                          while (1) {
                            switch (_context4.prev = _context4.next) {
                              case 0:
                                _context4.prev = 0;
                                _context4.next = 3;
                                return source.forNode(info);

                              case 3:
                                return _context4.abrupt("return", _context4.sent);

                              case 6:
                                _context4.prev = 6;
                                _context4.t0 = _context4["catch"](0);
                                return _context4.abrupt("return", null);

                              case 9:
                              case "end":
                                return _context4.stop();
                            }
                          }
                        }, _callee4, null, [[0, 6]]);
                      }));

                      return function (_x10) {
                        return _ref2.apply(this, arguments);
                      };
                    }()));

                  case 7:
                    contents = _context5.sent;
                    return _context5.abrupt("return", {
                      contents: contents.filter(removeFalsey),
                      range: toMonacoRange(graphqlLanguageService.getRange({
                        column: info.position.character,
                        line: info.position.line + 1
                      }, info.document))
                    });

                  case 9:
                  case "end":
                    return _context5.stop();
                }
              }
            }, _callee5);
          }));

          function provideHover(_x8, _x9) {
            return _provideHover.apply(this, arguments);
          }

          return provideHover;
        }()
      };
    }
  }, {
    key: "handleDecorations",
    value: function () {
      var _handleDecorations = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee6(decorationSources, model, monacoInstance, editorInstance) {
        var _iterator, _step, source;

        return regeneratorRuntime.wrap(function _callee6$(_context6) {
          while (1) {
            switch (_context6.prev = _context6.next) {
              case 0:
                _iterator = _createForOfIteratorHelper(decorationSources);

                try {
                  for (_iterator.s(); !(_step = _iterator.n()).done;) {
                    source = _step.value;
                    source.forDocument({
                      monaco: monacoInstance,
                      editor: editorInstance,
                      document: model.getValue(),
                      model: model,
                      languageService: this
                    });
                  }
                } catch (err) {
                  _iterator.e(err);
                } finally {
                  _iterator.f();
                }

              case 2:
              case "end":
                return _context6.stop();
            }
          }
        }, _callee6, this);
      }));

      function handleDecorations(_x11, _x12, _x13, _x14) {
        return _handleDecorations.apply(this, arguments);
      }

      return handleDecorations;
    }()
  }, {
    key: "handleDiagnostics",
    value: function () {
      var _handleDiagnostics = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee8(rawDiagnosticsSources, model, monacoInstance) {
        var _this3 = this,
            _ref4;

        var diagnosticsSources, nestedArrays, markerData;
        return regeneratorRuntime.wrap(function _callee8$(_context8) {
          while (1) {
            switch (_context8.prev = _context8.next) {
              case 0:
                diagnosticsSources = [].concat(_toConsumableArray(rawDiagnosticsSources), [coreDiagnosticsSource]);
                _context8.next = 3;
                return Promise.all(diagnosticsSources.map( /*#__PURE__*/function () {
                  var _ref3 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee7(source) {
                    return regeneratorRuntime.wrap(function _callee7$(_context7) {
                      while (1) {
                        switch (_context7.prev = _context7.next) {
                          case 0:
                            _context7.prev = 0;
                            _context7.next = 3;
                            return source.forDocument({
                              languageService: _this3,
                              model: model,
                              document: model.getValue().toString()
                            });

                          case 3:
                            return _context7.abrupt("return", _context7.sent);

                          case 6:
                            _context7.prev = 6;
                            _context7.t0 = _context7["catch"](0);
                            return _context7.abrupt("return", null);

                          case 9:
                          case "end":
                            return _context7.stop();
                        }
                      }
                    }, _callee7, null, [[0, 6]]);
                  }));

                  return function (_x18) {
                    return _ref3.apply(this, arguments);
                  };
                }()));

              case 3:
                nestedArrays = _context8.sent.filter(removeFalsey);
                markerData = (_ref4 = []).concat.apply(_ref4, _toConsumableArray(nestedArrays));
                monacoInstance.editor.setModelMarkers(model, 'graphql', markerData);

              case 6:
              case "end":
                return _context8.stop();
            }
          }
        }, _callee8);
      }));

      function handleDiagnostics(_x15, _x16, _x17) {
        return _handleDiagnostics.apply(this, arguments);
      }

      return handleDiagnostics;
    }()
  }, {
    key: "getModelChangeHandler",
    value: function getModelChangeHandler() {
      var _this4 = this;

      return /*#__PURE__*/function () {
        var _ref5 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee9(editorInstance, monacoInstance, diagnosticsSources, decorationsSources) {
          var model;
          return regeneratorRuntime.wrap(function _callee9$(_context9) {
            while (1) {
              switch (_context9.prev = _context9.next) {
                case 0:
                  model = editorInstance.getModel();

                  if (model) {
                    _context9.next = 3;
                    break;
                  }

                  return _context9.abrupt("return");

                case 3:
                  _context9.next = 5;
                  return Promise.all([_this4.handleDiagnostics(diagnosticsSources, model, monacoInstance), _this4.handleDecorations(decorationsSources, model, monacoInstance, editorInstance)]);

                case 5:
                case "end":
                  return _context9.stop();
              }
            }
          }, _callee9);
        }));

        return function (_x19, _x20, _x21, _x22) {
          return _ref5.apply(this, arguments);
        };
      }();
    }
  }, {
    key: "trySchema",
    value: function trySchema(sdl) {
      var _this5 = this;

      // XX-DOTAN: In case of an issue with the schema parsing, we'll get the error through
      // the Marker, and we can safely ignore it here.
      // eslint-disable-next-line @typescript-eslint/no-empty-function
      return this.setSchema(sdl).then(function () {
        return _this5.getSchema();
      });
    }
  }]);

  return EnrichedLanguageService;
}(graphqlLanguageService.LanguageService);

function _typeof$1(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof$1 = function _typeof(obj) { return typeof obj; }; } else { _typeof$1 = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof$1(obj); }

/**
 * Return true if `value` is object-like. A value is object-like if it's not
 * `null` and has a `typeof` result of "object".
 */
function isObjectLike(value) {
  return _typeof$1(value) == 'object' && value !== null;
}

// In ES2015 (or a polyfilled) environment, this will be Symbol.iterator

var SYMBOL_TO_STRING_TAG = typeof Symbol === 'function' && Symbol.toStringTag != null ? Symbol.toStringTag : '@@toStringTag';

/**
 * Represents a location in a Source.
 */

/**
 * Takes a Source and a UTF-8 character offset, and returns the corresponding
 * line and column as a SourceLocation.
 */
function getLocation(source, position) {
  var lineRegexp = /\r\n|[\n\r]/g;
  var line = 1;
  var column = position + 1;
  var match;

  while ((match = lineRegexp.exec(source.body)) && match.index < position) {
    line += 1;
    column = position + 1 - (match.index + match[0].length);
  }

  return {
    line: line,
    column: column
  };
}

/**
 * Render a helpful description of the location in the GraphQL Source document.
 */

function printLocation(location) {
  return printSourceLocation(location.source, getLocation(location.source, location.start));
}
/**
 * Render a helpful description of the location in the GraphQL Source document.
 */

function printSourceLocation(source, sourceLocation) {
  var firstLineColumnOffset = source.locationOffset.column - 1;
  var body = whitespace(firstLineColumnOffset) + source.body;
  var lineIndex = sourceLocation.line - 1;
  var lineOffset = source.locationOffset.line - 1;
  var lineNum = sourceLocation.line + lineOffset;
  var columnOffset = sourceLocation.line === 1 ? firstLineColumnOffset : 0;
  var columnNum = sourceLocation.column + columnOffset;
  var locationStr = "".concat(source.name, ":").concat(lineNum, ":").concat(columnNum, "\n");
  var lines = body.split(/\r\n|[\n\r]/g);
  var locationLine = lines[lineIndex]; // Special case for minified documents

  if (locationLine.length > 120) {
    var subLineIndex = Math.floor(columnNum / 80);
    var subLineColumnNum = columnNum % 80;
    var subLines = [];

    for (var i = 0; i < locationLine.length; i += 80) {
      subLines.push(locationLine.slice(i, i + 80));
    }

    return locationStr + printPrefixedLines([["".concat(lineNum), subLines[0]]].concat(subLines.slice(1, subLineIndex + 1).map(function (subLine) {
      return ['', subLine];
    }), [[' ', whitespace(subLineColumnNum - 1) + '^'], ['', subLines[subLineIndex + 1]]]));
  }

  return locationStr + printPrefixedLines([// Lines specified like this: ["prefix", "string"],
  ["".concat(lineNum - 1), lines[lineIndex - 1]], ["".concat(lineNum), locationLine], ['', whitespace(columnNum - 1) + '^'], ["".concat(lineNum + 1), lines[lineIndex + 1]]]);
}

function printPrefixedLines(lines) {
  var existingLines = lines.filter(function (_ref) {
    _ref[0];
        var line = _ref[1];
    return line !== undefined;
  });
  var padLen = Math.max.apply(Math, existingLines.map(function (_ref2) {
    var prefix = _ref2[0];
    return prefix.length;
  }));
  return existingLines.map(function (_ref3) {
    var prefix = _ref3[0],
        line = _ref3[1];
    return leftPad(padLen, prefix) + (line ? ' | ' + line : ' |');
  }).join('\n');
}

function whitespace(len) {
  return Array(len + 1).join(' ');
}

function leftPad(len, str) {
  return whitespace(len - str.length) + str;
}

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _wrapNativeSuper(Class) { var _cache = typeof Map === "function" ? new Map() : undefined; _wrapNativeSuper = function _wrapNativeSuper(Class) { if (Class === null || !_isNativeFunction(Class)) return Class; if (typeof Class !== "function") { throw new TypeError("Super expression must either be null or a function"); } if (typeof _cache !== "undefined") { if (_cache.has(Class)) return _cache.get(Class); _cache.set(Class, Wrapper); } function Wrapper() { return _construct(Class, arguments, _getPrototypeOf(this).constructor); } Wrapper.prototype = Object.create(Class.prototype, { constructor: { value: Wrapper, enumerable: false, writable: true, configurable: true } }); return _setPrototypeOf(Wrapper, Class); }; return _wrapNativeSuper(Class); }

function _construct(Parent, args, Class) { if (_isNativeReflectConstruct()) { _construct = Reflect.construct; } else { _construct = function _construct(Parent, args, Class) { var a = [null]; a.push.apply(a, args); var Constructor = Function.bind.apply(Parent, a); var instance = new Constructor(); if (Class) _setPrototypeOf(instance, Class.prototype); return instance; }; } return _construct.apply(null, arguments); }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _isNativeFunction(fn) { return Function.toString.call(fn).indexOf("[native code]") !== -1; }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }
/**
 * A GraphQLError describes an Error found during the parse, validate, or
 * execute phases of performing a GraphQL operation. In addition to a message
 * and stack trace, it also includes information about the locations in a
 * GraphQL document and/or execution result that correspond to the Error.
 */

var GraphQLError = /*#__PURE__*/function (_Error) {
  _inherits(GraphQLError, _Error);

  var _super = _createSuper(GraphQLError);

  /**
   * A message describing the Error for debugging purposes.
   *
   * Enumerable, and appears in the result of JSON.stringify().
   *
   * Note: should be treated as readonly, despite invariant usage.
   */

  /**
   * An array of { line, column } locations within the source GraphQL document
   * which correspond to this error.
   *
   * Errors during validation often contain multiple locations, for example to
   * point out two things with the same name. Errors during execution include a
   * single location, the field which produced the error.
   *
   * Enumerable, and appears in the result of JSON.stringify().
   */

  /**
   * An array describing the JSON-path into the execution response which
   * corresponds to this error. Only included for errors during execution.
   *
   * Enumerable, and appears in the result of JSON.stringify().
   */

  /**
   * An array of GraphQL AST Nodes corresponding to this error.
   */

  /**
   * The source GraphQL document for the first location of this error.
   *
   * Note that if this Error represents more than one node, the source may not
   * represent nodes after the first node.
   */

  /**
   * An array of character offsets within the source GraphQL document
   * which correspond to this error.
   */

  /**
   * The original error thrown from a field resolver during execution.
   */

  /**
   * Extension fields to add to the formatted error.
   */
  function GraphQLError(message, nodes, source, positions, path, originalError, extensions) {
    var _locations2, _source2, _positions2, _extensions2;

    var _this;

    _classCallCheck(this, GraphQLError);

    _this = _super.call(this, message); // Compute list of blame nodes.

    var _nodes = Array.isArray(nodes) ? nodes.length !== 0 ? nodes : undefined : nodes ? [nodes] : undefined; // Compute locations in the source for the given nodes/positions.


    var _source = source;

    if (!_source && _nodes) {
      var _nodes$0$loc;

      _source = (_nodes$0$loc = _nodes[0].loc) === null || _nodes$0$loc === void 0 ? void 0 : _nodes$0$loc.source;
    }

    var _positions = positions;

    if (!_positions && _nodes) {
      _positions = _nodes.reduce(function (list, node) {
        if (node.loc) {
          list.push(node.loc.start);
        }

        return list;
      }, []);
    }

    if (_positions && _positions.length === 0) {
      _positions = undefined;
    }

    var _locations;

    if (positions && source) {
      _locations = positions.map(function (pos) {
        return getLocation(source, pos);
      });
    } else if (_nodes) {
      _locations = _nodes.reduce(function (list, node) {
        if (node.loc) {
          list.push(getLocation(node.loc.source, node.loc.start));
        }

        return list;
      }, []);
    }

    var _extensions = extensions;

    if (_extensions == null && originalError != null) {
      var originalExtensions = originalError.extensions;

      if (isObjectLike(originalExtensions)) {
        _extensions = originalExtensions;
      }
    }

    Object.defineProperties(_assertThisInitialized(_this), {
      name: {
        value: 'GraphQLError'
      },
      message: {
        value: message,
        // By being enumerable, JSON.stringify will include `message` in the
        // resulting output. This ensures that the simplest possible GraphQL
        // service adheres to the spec.
        enumerable: true,
        writable: true
      },
      locations: {
        // Coercing falsy values to undefined ensures they will not be included
        // in JSON.stringify() when not provided.
        value: (_locations2 = _locations) !== null && _locations2 !== void 0 ? _locations2 : undefined,
        // By being enumerable, JSON.stringify will include `locations` in the
        // resulting output. This ensures that the simplest possible GraphQL
        // service adheres to the spec.
        enumerable: _locations != null
      },
      path: {
        // Coercing falsy values to undefined ensures they will not be included
        // in JSON.stringify() when not provided.
        value: path !== null && path !== void 0 ? path : undefined,
        // By being enumerable, JSON.stringify will include `path` in the
        // resulting output. This ensures that the simplest possible GraphQL
        // service adheres to the spec.
        enumerable: path != null
      },
      nodes: {
        value: _nodes !== null && _nodes !== void 0 ? _nodes : undefined
      },
      source: {
        value: (_source2 = _source) !== null && _source2 !== void 0 ? _source2 : undefined
      },
      positions: {
        value: (_positions2 = _positions) !== null && _positions2 !== void 0 ? _positions2 : undefined
      },
      originalError: {
        value: originalError
      },
      extensions: {
        // Coercing falsy values to undefined ensures they will not be included
        // in JSON.stringify() when not provided.
        value: (_extensions2 = _extensions) !== null && _extensions2 !== void 0 ? _extensions2 : undefined,
        // By being enumerable, JSON.stringify will include `path` in the
        // resulting output. This ensures that the simplest possible GraphQL
        // service adheres to the spec.
        enumerable: _extensions != null
      }
    }); // Include (non-enumerable) stack trace.

    if (originalError !== null && originalError !== void 0 && originalError.stack) {
      Object.defineProperty(_assertThisInitialized(_this), 'stack', {
        value: originalError.stack,
        writable: true,
        configurable: true
      });
      return _possibleConstructorReturn(_this);
    } // istanbul ignore next (See: 'https://github.com/graphql/graphql-js/issues/2317')


    if (Error.captureStackTrace) {
      Error.captureStackTrace(_assertThisInitialized(_this), GraphQLError);
    } else {
      Object.defineProperty(_assertThisInitialized(_this), 'stack', {
        value: Error().stack,
        writable: true,
        configurable: true
      });
    }

    return _this;
  }

  _createClass(GraphQLError, [{
    key: "toString",
    value: function toString() {
      return printError(this);
    } // FIXME: workaround to not break chai comparisons, should be remove in v16
    // $FlowFixMe[unsupported-syntax] Flow doesn't support computed properties yet

  }, {
    key: SYMBOL_TO_STRING_TAG,
    get: function get() {
      return 'Object';
    }
  }]);

  return GraphQLError;
}( /*#__PURE__*/_wrapNativeSuper(Error));
/**
 * Prints a GraphQLError to a string, representing useful location information
 * about the error's position in the source.
 */

function printError(error) {
  var output = error.message;

  if (error.nodes) {
    for (var _i2 = 0, _error$nodes2 = error.nodes; _i2 < _error$nodes2.length; _i2++) {
      var node = _error$nodes2[_i2];

      if (node.loc) {
        output += '\n\n' + printLocation(node.loc);
      }
    }
  } else if (error.source && error.locations) {
    for (var _i4 = 0, _error$locations2 = error.locations; _i4 < _error$locations2.length; _i4++) {
      var location = _error$locations2[_i4];
      output += '\n\n' + printSourceLocation(error.source, location);
    }
  }

  return output;
}

var _excluded = ["schema", "hoverProviders", "definitionProviders", "diagnosticsProviders", "decorationsProviders", "actions", "keyboardShortcuts", "sharedLanguageService", "onBlur", "onLanguageServiceReady", "onSchemaChange", "onSchemaError"];
var SchemaEditor = function SchemaEditor(_ref) {
  var schema = _ref.schema,
      _ref$hoverProviders = _ref.hoverProviders,
      hoverProviders = _ref$hoverProviders === void 0 ? [] : _ref$hoverProviders,
      _ref$definitionProvid = _ref.definitionProviders,
      definitionProviders = _ref$definitionProvid === void 0 ? [] : _ref$definitionProvid,
      _ref$diagnosticsProvi = _ref.diagnosticsProviders,
      diagnosticsProviders = _ref$diagnosticsProvi === void 0 ? [] : _ref$diagnosticsProvi,
      _ref$decorationsProvi = _ref.decorationsProviders,
      decorationsProviders = _ref$decorationsProvi === void 0 ? [] : _ref$decorationsProvi,
      _ref$actions = _ref.actions,
      actions = _ref$actions === void 0 ? [] : _ref$actions,
      keyboardShortcuts = _ref.keyboardShortcuts,
      sharedLanguageService = _ref.sharedLanguageService,
      onBlur = _ref.onBlur,
      onLanguageServiceReady = _ref.onLanguageServiceReady,
      onSchemaChange = _ref.onSchemaChange,
      onSchemaError = _ref.onSchemaError,
      rest = _objectWithoutProperties(_ref, _excluded);

  var _React$useState = React__namespace.useState(null),
      _React$useState2 = _slicedToArray(_React$useState, 2),
      editorRef = _React$useState2[0],
      setEditor = _React$useState2[1];

  var _React$useState3 = React__namespace.useState(null),
      _React$useState4 = _slicedToArray(_React$useState3, 2),
      monacoRef = _React$useState4[0],
      setMonaco = _React$useState4[1];

  var languageService = React__namespace.useMemo(function () {
    return sharedLanguageService || new EnrichedLanguageService({
      schemaString: schema,
      schemaConfig: {
        buildSchemaOptions: {
          assumeValid: true,
          assumeValidSDL: true
        }
      }
    });
  }, [sharedLanguageService]);
  React__namespace.useEffect(function () {
    if (languageService && onLanguageServiceReady) {
      onLanguageServiceReady(languageService);
    }
  }, [languageService, onLanguageServiceReady]);
  React__namespace.useEffect(function () {
    if (monacoRef && editorRef) {
      if (keyboardShortcuts) {
        var _iterator = _createForOfIteratorHelper(keyboardShortcuts(editorRef, monacoRef)),
            _step;

        try {
          for (_iterator.s(); !(_step = _iterator.n()).done;) {
            var action = _step.value;
            editorRef.addAction(action);
          }
        } catch (err) {
          _iterator.e(err);
        } finally {
          _iterator.f();
        }
      }

      var _iterator2 = _createForOfIteratorHelper(actions),
          _step2;

      try {
        var _loop = function _loop() {
          var action = _step2.value;
          editorRef.addAction({
            id: action.id,
            label: action.label,
            keybindings: action.keybindings,
            contextMenuGroupId: action.contextMenuGroupId || 'navigation',
            contextMenuOrder: action.contextMenuOrder,
            run: function () {
              var _run = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(editor) {
                var model, position, bridge;
                return regeneratorRuntime.wrap(function _callee$(_context) {
                  while (1) {
                    switch (_context.prev = _context.next) {
                      case 0:
                        model = editor.getModel();
                        position = editor.getPosition();

                        if (!(model && position)) {
                          _context.next = 7;
                          break;
                        }

                        _context.next = 5;
                        return languageService.buildBridgeForProviders(model, position);

                      case 5:
                        bridge = _context.sent;

                        if (bridge) {
                          action.onRun({
                            editor: editorRef,
                            monaco: monacoRef,
                            bridge: bridge
                          });
                        }

                      case 7:
                      case "end":
                        return _context.stop();
                    }
                  }
                }, _callee);
              }));

              function run(_x) {
                return _run.apply(this, arguments);
              }

              return run;
            }()
          });
        };

        for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
          _loop();
        }
      } catch (err) {
        _iterator2.e(err);
      } finally {
        _iterator2.f();
      }

      var handler = languageService.getModelChangeHandler();
      handler(editorRef, monacoRef, diagnosticsProviders, decorationsProviders);
      var onChangeDisposable = editorRef.onDidChangeModelContent(function () {
        return handler(editorRef, monacoRef, diagnosticsProviders, decorationsProviders);
      });
      var definitionProviderDisposable = monacoRef.languages.registerDefinitionProvider('graphql', languageService.getDefinitionProvider(definitionProviders));
      var hoverDisposable = monacoRef.languages.registerHoverProvider('graphql', languageService.getHoverProvider(hoverProviders));
      return function () {
        hoverDisposable && hoverDisposable.dispose();
        definitionProviderDisposable && definitionProviderDisposable.dispose();
        onChangeDisposable && onChangeDisposable.dispose();
      };
    } // eslint-disable-next-line @typescript-eslint/no-empty-function


    return function () {};
  }, [editorRef, monacoRef]);

  var _React$useState5 = React__namespace.useState(),
      _React$useState6 = _slicedToArray(_React$useState5, 2),
      onBlurHandler = _React$useState6[0],
      setOnBlurSubscription = _React$useState6[1];

  React__namespace.useEffect(function () {
    if (editorRef && onBlur) {
      onBlurHandler === null || onBlurHandler === void 0 ? void 0 : onBlurHandler.dispose();
      var subscription = editorRef.onDidBlurEditorText(function () {
        onBlur(editorRef.getValue() || '');
      });
      setOnBlurSubscription(subscription);
    }
  }, [onBlur, editorRef]);
  return /*#__PURE__*/React__namespace.createElement(React__namespace.Fragment, null, /*#__PURE__*/React__namespace.createElement(MonacoEditor__default['default'], _extends({
    height: '70vh'
  }, rest, {
    beforeMount: function beforeMount(monaco) {
      rest.beforeMount && rest.beforeMount(monaco);
      setMonaco(monaco);
    },
    onMount: function onMount(editor, monaco) {
      rest.onMount && rest.onMount(editor, monaco);
      setEditor(editor);
    },
    onChange: function onChange(newValue, ev) {
      rest.onChange && rest.onChange(newValue, ev);

      if (newValue) {
        languageService.trySchema(newValue).then(function (schema) {
          if (schema) {
            onSchemaChange && onSchemaChange(schema, newValue);
          }
        }).catch(function (e) {
          if (onSchemaError) {
            if (e instanceof GraphQLError) {
              onSchemaError([e], newValue, languageService);
            } else {
              onSchemaError([new GraphQLError(e.message, undefined, undefined, undefined, undefined, e)], newValue, languageService);
            }
          }
        });
      }
    },
    options: _objectSpread2({
      glyphMargin: true
    }, rest.options || {}),
    language: "graphql",
    defaultValue: rest.defaultValue || schema
  })));
};

Object.defineProperty(exports, 'getRange', {
  enumerable: true,
  get: function () {
    return graphqlLanguageService.getRange;
  }
});
exports.EnrichedLanguageService = EnrichedLanguageService;
exports.SchemaEditor = SchemaEditor;
exports.coreDefinitionSource = coreDefinitionSource;
exports.coreDiagnosticsSource = coreDiagnosticsSource;
exports.coreHoverSource = coreHoverSource;
exports.debugHoverSource = debugHoverSource;
exports.removeFalsey = removeFalsey;
exports.showWidgetInPosition = showWidgetInPosition;
exports.toGraphQLPosition = toGraphQLPosition;
exports.toMarkerData = toMarkerData;
exports.toMonacoRange = toMonacoRange;
//# sourceMappingURL=index.js.map
